﻿
// ChildView.cpp : CChildView クラスの実装
//

#include "pch.h"
#include "framework.h"
#include "MFCuda.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_WM_CREATE()
END_MESSAGE_MAP()



// CChildView メッセージ ハンドラー

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(nullptr, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), nullptr);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // 描画のデバイス コンテキスト
	
	BITMAP bmpinfo;
	bmp.GetBitmap(&bmpinfo);
	int w2 = bmpinfo.bmWidth;
	int h2 = bmpinfo.bmHeight;

	CDC dc2;
	dc2.CreateCompatibleDC(GetDC());
	dc2.SelectObject(bmp);

	// TODO: ここにメッセージ ハンドラー コードを追加します。
	RECT rc;
	POINT pt;
	GetWindowRect(&rc);
	int w = rc.right - rc.left;
	int h = rc.bottom - rc.top;
	
	// dc.StretchBlt(0, 0, w, h, &dc2, 0, 0, w2, h2, SRCCOPY);
	dc.BitBlt(0, 0, w2, h2, &dc2, 0, 0, SRCCOPY);
}



int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO: ここに特定な作成コードを追加してください。
	bmp.CreateCompatibleBitmap(GetDC(), 800, 600);

	return 0;
}


// ちらつき防止にバックバッファ(bmp)に書き込む
int CChildView::PrePaint()
{
	// TODO: ここに実装コードを追加します.
	BITMAP bmpinfo;
	bmp.GetBitmap(&bmpinfo);
	int w = bmpinfo.bmWidth;
	int h = bmpinfo.bmHeight;

	CDC dc;
	dc.CreateCompatibleDC(GetDC());
	dc.SelectObject(bmp);

	// TODO: ここにメッセージ ハンドラー コードを追加します。
	POINT pt;

	CPen penRed(PS_SOLID, 2, RGB(255, 0, 0));
	CPen penYellow(PS_SOLID, 1, RGB(255, 255, 0));
	CBrush brs, brs2;
	brs.CreateSolidBrush(RGB(0, 0, 0));
	brs2.CreateSolidBrush(RGB(255, 0, 0));
	dc.SelectObject(brs);
	dc.Rectangle(0, 0, w, h);
	dc.SelectObject(brs2);

	dc.SelectObject(penRed);
	std::vector<GameCharactor>& chars = p_game_data->field.chars;
	int n = chars.size();
	for (auto a : chars) {
		pt.x = (int)(a.x * w);
		pt.y = (int)(a.y * h);
		dc.Ellipse(pt.x - 2, pt.y - 2, pt.x + 2, pt.y + 2);
	}

	dc.SelectObject(penYellow);
	n = chars.size();
	for (int i = 0; i < n; i++) {
		int nr = chars[i].near_id;
		if (nr == -1)
			continue;

		dc.MoveTo((int)(chars[i].x * w), (int)(chars[i].y * h));
		dc.LineTo((int)(chars[nr].x * w), (int)(chars[nr].y * h));
	}
	CString str;
	str.Format(_T("%dms"), p_game_data->field.ms);
	CFont font;
	font.CreatePointFont(120, _T("MS ゴシック"));
	dc.SelectObject(font);
	dc.SetTextColor(RGB(255, 255, 255));
	dc.SetBkColor(RGB(0, 0, 0));
	dc.TextOutW(4, 4, str);
	return 0;
}
